from re import Pattern


class Route:
	_routes = {}
	_reg_routes = []

	def __init__(self, route, methods=[], method="GET"):
		self._route = None
		if type(route) == str:
			if route[0] != "/":
				raise Exception("Route must starts with '/'! (%s)" % route)
			self._route = route if route[-1] == ("/") else route + "/"
		elif type(route) == Pattern:
			self._route = route
		else:
			raise Exception("Route must be str or re.Pattern type! (%s, %s)" % (route, str(type(route))))
		self._methods = methods if len(methods) else [method or "GET"]

	def __call__(self, fce, *args):
		if type(self._route) == Pattern:
			self._reg_routes.append((self._route, fce, self._methods))
		elif self._route:
			for method in self._methods:
				if not self._routes.get(self._route):
					self._routes[self._route] = {}
				if self._routes[self._route].get(method):
					raise Exception("Route alreay set! (%s - %s)" % self._routes.get(method, self._route))
				self._routes[self._route][method] = fce

	@staticmethod
	def get(path, method):
		route = Route._routes.get(path if path[-1] == "/" else path + "/", {})
		function = route.get(method, False)
		if function:
			return function, (), None
		else:
			for item in Route._reg_routes:
				match = item[0].match(path)
				if match:
					route, function = True, False
					if method in item[2]:
						return item[1], match.groups(0), None
		if route and not function:
			return None, (), True
		return None, (), False
