import setuptools

with open("README.md", "r") as fh:
	long_description = fh.read()


setuptools.setup(
	name="WeefPy",
	version="1.0.4",
	entry_points={
		'console_scripts': ['weef_server=WeefPy.weef_server:server'],
	},
	author="Patrik Katrenak",
	author_email="patrik@katryapps.com",
	description="Tiny Python web API framework",
	long_description=long_description,
	long_description_content_type="text/markdown",
	url="https://gitlab.com/katry/WeefPy",
	data_files=[("WeefPy", ["WeefPy/codes.json"])],
	packages=["WeefPy"],
	install_requires=["orjson"],
	classifiers=[
		"Programming Language :: Python :: 3",
		"License :: OSI Approved :: GNU Lesser General Public License v3 (LGPLv3)",
		"Operating System :: OS Independent",
	],
	platforms=["any"],
	python_requires=">=3.8",
)
